#!/usr/bin/python

"""
Song 20
Using The New Interface to CSound
It makes far less random songs.
This is because it changes the extents for drum and electricGuitar.
SEE csound.__doc__
"""

import csound

from theremin import theremin

class Song20(csound.Song):
	"""
	Every song is a subclass of the generic song!
	This song is called 20 (in order chrono-numerically).
	"""
	def __init__(self):
		"""
		Creates the initial data for the Song.
		"""
		self.oOrchestra = csound.Orchestra()

		self.theremin2 = self.oOrchestra.addInstrument(theremin())
		self.theremin2.setExtents([csound.Extent(0.25, 3, 0.25), # duration
			csound.Extent(4000, 10000, 1000), # amplitude1
			csound.Extent(4000, 10000, 1000), # amplitude2
			csound.Extent(110, 2000, 110),    # frequency1
			csound.Extent(110, 2000, 110),    # frequency2
			csound.Extent(0.0, 0.3, 0.1),     # wobble
			csound.Extent(0, 0.3, 0.1)])      # noise

		self.oScore = csound.Score()
		# use GEN10 to compute a sine wave
		self.oScore.addFunction('f1	0	4096	10	1')
		self.oPatch = csound.Patch(0.5)
		self.oScore.addPatch(self.oPatch)

		curTime = 0.0
		while curTime < 60.0:
			lNote = self.theremin2.playRandomNote(curTime)
			if lNote != None: # no rest for theremin
				fDuration = lNote[2] # start a new note
									 # when the previous one ends.
				self.oPatch.addNote(lNote)
				curTime += fDuration
			#end if
		#end while
	#end def __init__(self)
#end class Song20(csound.Song)



def main():
	"""
	A test function for csound extention.
	"""
	print csound.__doc__
	oTest = Song20()
	oTest.printOutput()
#end def main()

if __name__ == '__main__':
	main()
#end if

